using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using AddinExpress.XL;
using Excel = Microsoft.Office.Interop.Excel;

namespace MyAddin255
{  
    public partial class ADXExcelTaskPane1 : AddinExpress.XL.ADXExcelTaskPane
    {
        public ADXExcelTaskPane1()
        {
            InitializeComponent();
            this.label1.Text = "Created at " + System.DateTime.Now.ToLongTimeString();
        }

        private string GetWindowCaption() {
            string text = "";
            Excel._Application ExcelApp = ExcelAppObj as Excel._Application;
            Excel.Windows windows = ExcelApp.Windows;
            int hwnd = (int)hostHandle;
            for (int i = 1; i <= windows.Count; i++) {
                Excel.Window window = windows[i];
                if (window.Hwnd == hwnd) {
                    text = window.Caption.ToString();
                }
                Marshal.ReleaseComObject(window);
                if (text != "") break;
            }
            Marshal.ReleaseComObject(windows);
            return text;
        }

        private IntPtr hostHandle = IntPtr.Zero;
        private void ADXExcelTaskPane1_ADXBeforeTaskPaneShow(object sender, ADXBeforeTaskPaneShowEventArgs e) {
            System.Diagnostics.Debug.WriteLine("!!! ADXExcelTaskPane1_ADXBeforeTaskPaneShow");
            hostHandle = (IntPtr)GetType().InvokeMember("HostHandle", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.GetProperty | System.Reflection.BindingFlags.Instance, null, this, null);
            this.label2.Text = "Shown at " + System.DateTime.Now.ToLongTimeString();
            string text = GetWindowCaption();
            if (text != "") {
                this.label3.Text = "Shown in " + text;
            } else {
                this.label3.Text = "???";
            }
        }

        private void ADXExcelTaskPane1_ADXAfterTaskPaneHide(object sender, ADXAfterTaskPaneHideEventArgs e) {
            System.Diagnostics.Debug.WriteLine("!!! ADXExcelTaskPane1_ADXAfterTaskPaneHide");
        }

        internal string GetLabel() {
            return this.label3.Text;
        }
    }
}
